package editeur;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Point;
import java.util.ArrayList;
import java.util.List;

import javax.swing.JComponent;

public class Planche extends JComponent {

	private static final int TAILLE_POINT = 2;
	private static final int EPSILON = 20;
	private List<Point> points = new ArrayList<Point>();
	private List<Forme> formes = new ArrayList<Forme>();

	public Planche() {
		setOpaque(true);
		setForeground(Color.black);
		setBackground(Color.white);
	}

	public void paintComponent(Graphics g) {
		if (isOpaque()) {
			g.setColor(getBackground());
			g.fillRect(0, 0, getWidth(), getHeight());
		}
		g.setColor(getForeground());
		for (Point p : points) {
			g.drawLine(p.x - TAILLE_POINT, p.y, p.x + TAILLE_POINT, p.y);
			g.drawLine(p.x, p.y - TAILLE_POINT, p.x, p.y + TAILLE_POINT);
		}
		for (Forme e : formes)
			e.dessine(g);
	}

	public void ajouterPoint(Point p) throws PointExistantException {
		Point p2 = point(p);
		if (p2 != null) {
			throw new PointExistantException(p2);
		}
		points.add(p);
		repaint();
	}

	public Point point(int x, int y) {
		for (Point p : points)
			if (x >= p.x - EPSILON && x <= p.x + EPSILON && y >= p.y - EPSILON
					&& y <= p.y + EPSILON)
				return p;
		return null;
	}

	public Point point(Point p) {
		return point(p.x, p.y);
	}

	public void ajouterForme(Forme e) {
		formes.add(e);
		System.out.println("Ajout de " + e);
		repaint();
	}
}
